{
Unit DBAnsiView : TDBAnsiView component.
Written by C.Geng from P.R.China, 1998

Add DB-AWare ability to the TAnsiView.

Component to display ansi-colored file such as BBS articles
in Delphi application.

Anyhow, the code is not completed, quite a lot of ansi
control function has not been implemented.  I will try,
but if you have any good idea, please
email me: fuse@bbs.zju.ml.org

Big thanks to Alexander Kuznetsov (sanhome@hotmail.com)
for his jmpmemo component, I setup the structure of my
code based on it.
Some ansi output code is borrowed from GAYLE DAVIS/DAVID ANDERSON
I get it from SWAG.  Thanks to their good work!
}

unit dbansivw;

interface

uses
   SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
   Forms, Dialogs, StdCtrls, Printers, dbctrls, db, ansiview;
   {$M+}

type

  {------------------------------------------------------------------}
  TBackgroundStyle = (bsNoBitmap, bsStretched, bsTiled, bsTiledAndScrolled);
  {------------------------------------------------------------------}

   TDBAnsiView = class(TAnsiView)
   private
      { Private declarations }
      FEnabled : boolean;
      FDataLink: TFieldDataLink;
      function GetDataField: string;
      function GetDataSource: TDataSource;
      procedure SetDataField(const Value : string);
      procedure SetDataSource(Value: TDatasource);
      procedure DataChange(Sender: TObject);
      procedure UpdateData(Sender: TObject);
      procedure Change(Sender: TObject);
   protected
      { Protected declarations }
   public
      { Public declarations }
      constructor Create(AnOwner: TComponent); override;
      destructor Destroy; override;
   published
      { Published declarations }
      property Font;
      property Color;
      property Lines;
      property SelectColor;
      property TextColor;
      property Enabled : Boolean read FEnabled write FEnabled;
      property Align;
      property HelpContext;
      property BorderStyle;
      property ScrollBars;
      property ShowPages;
      property TabStop;
      property BackgroundBitmap;
      property BackgroundStyle;
      property DataField: string read GetDataField write SetDataField;
      property DataSource: TDataSource read GetDataSource write SetDataSource;
      property OnClick;
      property OnDblClick;
      property OnDragDrop;
      property OnDragOver;
      property OnEndDrag;
      property OnMouseDown;
      property OnMouseMove;
      property OnMouseUp;
      property OnStartDrag;
   end;


procedure Register;

implementation

Constructor TDBAnsiView.Create(AnOwner: TComponent);
begin
  inherited Create(AnOwner);
  FEnabled := true;
  FDataLink:=TFieldDataLink.Create;
  FDataLink.OnDataChange:=DataChange;
  FDataLink.OnUpdateData := UpdateData;
end;

destructor TDBAnsiView.Destroy;
begin
  FDataLink.OnDataChange:=nil;
  FDataLink.Free;
  inherited Destroy;
end;

function TDBAnsiView.GetDataField: string;
begin
  Result:=FDataLink.fieldname;
end;


function TDBAnsiView.GetDataSource:TDataSource;
begin
  Result:=FDataLink.DataSource;
end;

Procedure TDBAnsiView.SetDataField(const value: string);
begin
  FDataLink.FieldName:=Value;
end;

procedure TDBAnsiView.SetDataSource(Value: TDataSource);
begin
  FDataLink.DataSource:=Value;
end;

procedure TDBAnsiView.DataChange(Sender: TObject);
begin
  if FEnabled and (FDataLink.Field is TMemoField) then begin
    FLines.Assign(FDataLink.Field);
    RecalceMaxStrLen;
    RecalcRange;
    Refresh;
  end;
end;


procedure TDBAnsiView.UpdateData(Sender: TObject);
begin
end;

procedure TDBAnsiView.Change;
begin
  FDataLink.modified;
  inherited;
end;

procedure Register;
begin
   RegisterComponents('Letitbe', [TDBAnsiView]);
end;

end.
